.TH zeros 1 "April 1993" "Scilab Group" "Scilab Function"
.so ../sci.an
.SH NAME
zeros - matrix made of zeros
.SH CALLING SEQUENCE
.nf
y=zeros()
y=zeros(x)
y=zeros(m1,m2,..)
.fi
.SH PARAMETERS
.TP 10
x,y
: matrices
.TP 10
m1, m2,..
: integers
.SH DESCRIPTION
Creates matrix of zeros  (same as \fV0*ones\fR).
.TP 11
zeros(m1,m2) 
: for an \fV(m1,m2)\fR matrix.
.TP
zeros(m1,m2,..,mn) 
: creates a \fV(m1,m2,..,mn)\fR matrix filled with zeros
.TP
zeros(A)
: for a matrix of same size of \fVA\fR.
.TP
zeros(3)
: is \fVzeros(a)\fR with \fVa=3\fR i.e it is NOT a 3x3 matrix!
.TP
zeros() 
: returns a single zero
.LP
If \fVx\fR is a \fVsyslin\fR list (linear system in state-space or transfer
form), \fVzeros(x)\fR is also valid and returns a zero matrix.
.SH EXAMPLE
.nf
zeros(3)
zeros(3,3)
zeros(2,3,2)
.fi
.SH SEE ALSO
eye, ones, spzeros


