.TH karmarkar 1 "April 1993" "Scilab Group" "Scilab Function"
.so ../sci.an 
.SH NAME
karmarkar - karmarkar algorithm
.SH CALLING SEQUENCE
.nf
[x1]=karmarkar(a,b,c,x0)
.fi
.SH PARAMETERS
.TP
a     
: matrix (n,p)
.TP
b     
:  n - vector
.TP
c     
:  p - vector
.TP
x0    
:  initial vector
.TP
eps   
: threshold (default value : 1.d-5)
.TP
gamma 
: descent step  \fV0<gamma<1\fR , default value : 1/4
.TP
x1    
: solution 
.TP
crit  
: value of  c'*x1
.SH DESCRIPTION
Computes \fVx\fR which minimizes
.nf
                        c'*x
.fi
under constraints:
.nf
                        a*x = b
                        x>=0
.fi
.SH EXAMPLE
.nf
// n=10;p=20;
// a=rand(n,p);c=rand(p,1);x0=abs(rand(p,1));b=a*x0;x1=karmarkar(a,b,c,x0);
.fi
