.TH READC_f 5 "Janvier 1999" "Scilab Group" "Scicos Block"
.so ../sci.an
.SH NAME
READC_f - Scicos "read from C binary file" block 
.SH DIALOGUE PARAMETERS
.TP 20
Time record Selection
: an empty matrix or a positive integer. If an integer \fVi\fR is given
the  \fVi\fRth element of the read record is assumed to be the date of
the output event. If empty no output event exists.
.TP
Output record selection
: a vector of positive integer. \fV[k1,..,kn]\fR,The \fVki\fRth
element of  the read record gives the value of \fVi\fRth output.
.TP
Input file name
: a character string defining the path of the file 
.TP
Input Format
: a character string defining the  format to use 
.RS
.TP 13
"l","s","ul","us","d","f","c","uc"
: for reading  respectively  long, ashort, unsigned
long,  unsigned short, double,  float,  char and  unsigned
char. If required by the \fVswap mode\fR, the bytes which are
read are automatically swapped if necessary (by checking
little-endian status) in order to produce machine independent binary
files ( in little-endian mode).
.TP
"ull","uls","ubl","ubs",
: can be used for reading respectively unsigned little-endian long or
short and unsigned big-endian long or short. 
.TP
"dx","fx","lx","sx"
: with \fVx=b\fR or \fVx=l\fR can be used for reading
double, float, long or short as big or little endian.
.RE
.TP
Record size
:
The file is supposed to be formed by a sequence  of data with same
format. these data are organized in a sequence of record each of them
containing \fVRecord size\fR data.
.TP
Buffer size
: To improve efficiency it is possible to buffer the input data. read
on the file is only done after each \fVBuffer size\fR call to the
block.
.TP
Initial record index
: a scalar. This fixes the first record of the file to use.
.TP
Swap mode 
: With \fVSwap mode=1\fR  the file is supposed to
be coded in "little endian IEEE format" and data are swaped if
necessary to match the IEEE format of the processor. If \fVSwap mode=0\fR  then automatic bytes swap is disabled.
.SH DESCRIPTION
This block allows user to read datas in a C file.  \fVOutput record
selection\fR and \fVTime record Selection\fR allows the user to select
data among file records.

Each call to the block advance one record in the file. 

.SH SEE ALSO
RFILE_f, mget









