.TH Signal 1 "April 1993" "Scilab Group" "Scilab Function"
.so ../sci.an 
.SH NAME
Signal - Signal manual description
.SH FILTERS
.TP 15
analpf
: analog low-pass filter
.TP
buttmag
: squared magnitude response of a Butterworth filter
.TP
casc
: creates cascade realization of filter
.TP
cheb1mag
: square magnitude response of a type 1 Chebyshev filter
.TP
cheb2mag
: square magnitude response of a type 1 Chebyshev filter
.TP
chepol
: recursive implementation of Chebychev polynomial
.TP
convol
: convolution of 2 discrete series
.TP
ell1 mag
: squared magnitude of an elliptic filter
.TP
eqfir
: minimax multi-band, linear phase, FIR filter
.TP
eqiir
: design of iir filter
.TP
faurre
: optimal lqg filter.
.TP
lindquis
: optimal lqg filter lindquist algorithm
.TP
ffilt
: FIR low-pass,high-pass, band-pass, or stop-band filter
.TP
filter
: compute the filter model
.TP
find_freq
: parameter compatibility for elliptic filter design
.TP
findm
: for elliptic filter design
.TP
frmag
: magnitude of the frequency responses of FIR and IIR filters.
.TP
fsfirlin
: design of FIR, linear phase (frequency sampling technique)
.TP
fwiir
: optimum design of IIR filters in cascade realization,
.TP
iir
: designs an iir digital filter using analog filter designs.
.TP
iirgroup
: group delay of iir filter
.TP
iirlp
: Lp IIR filters optimization
.TP
group
: calculate the group delay of a digital filter
.TP
optfir
: optimal design of linear phase filters using linear programming
.TP
remezb
: minimax approximation of a frequency domain magnitude response.
.TP
kalm
: Kalman update and error variance
.TP
lev
: resolve the Yule-Walker equations
:
.TP
levin
: solve recursively Toeplitz system (normal equations)
.TP
srfaur
: square-root algorithm for the algebraic Riccati equation.
.TP
srkf
: square-root Kalman filter algorithm
.TP
sskf
: steady-state Kalman filter
.TP
system
: generates the next observation given the old state
.TP
trans
: transformation of standardized low-pass filter into low-pass,
high-pass, band-pass, stop-band.
.TP
wfir
: linear-phase windowed FIR low-pass, band-pass, high-pass, stop-band
.TP
wiener
: Wiener estimate (forward-backward Kalman filter formulation)
.TP
wigner
: time-frequency wigner spectrum of a signal.
.TP
window
: calculate symmetric window
.TP
zpbutt
: Butterworth analog filter
.TP
zpch1
: poles of a type 1 Chebyshev analog filter
.TP
zpch2
: poles and zeros of a type 2 Chebyshev analog filter
.TP
zpell
: poles and zeros of prototype lowpass elliptic filter
.SH Spectral estimation
.TP 15
corr
: correlation coefficients
.TP
cspect
: spectral estimation using the modified periodogram method.
.TP
czt
: chirp z-transform algorithm
.TP
intdec
: change the sampling rate of a 1D or 2D signal
.TP
mese
: calculate the maximum entropy spectral estimate
.TP
pspect
: auto and cross-spectral estimate
.TP
wigner
: Wigner-Ville time/frequency spectral estimation 
.SH Transforms
.TP 15
dft
: discrete Fourier transform
.TP 15
fft
: fast flourier transform
.TP
hilb
: Hilbert transform centred around the origin.
.TP
hank
: hankel matrix of the covariance sequence of a vector process
.TP
mfft
: fft for a multi-dimensional signal
.SH identification
.TP
lattn,lattp
: recursive solution of normal equations
.TP
phc
: State space realisation by the principal hankel component
 approximation method,
.TP
rpem
: identification by the recursive prediction error method
.SH MISCELLANEOUS
.TP
lgfft
: computes p = ceil (log_2(x))
.TP
sinc
: calculate the function sin(2*pi*fl*t)/(pi*t)
.TP
sincd
: calculates the function Sin(N*x)/Sin(x)
.TP
%k
: Jacobi's complete elliptic integral
.TP
%asn
: .TP
the elliptic integral
:
.TP
%sn
: Jacobi 's elliptic function with parameter m
.TP
bilt
: bilinear transform or biquadratic transform.
.TP
jmat
: permutes block rows or block columns of a matrix
.LP


